package com.zksy.controller.info;

import com.zksy.info.domain.EEnterpriseBasicInfo;
import com.zksy.info.service.EEnterpriseBasicInfoService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 企业信息控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/eenterpriseBasicInfo")
@Api(tags = "企业信息",description = "企业信息desc")
public class EEnterpriseBasicInfoController {
    @Autowired
    private EEnterpriseBasicInfoService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "企业信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String enterpriseName,String unifiedSocialCreditCode,String isAboveDesignatedSize,String isHighTech){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, enterpriseName, unifiedSocialCreditCode, isAboveDesignatedSize, isHighTech));
    }
    @GetMapping("/getEEnterpriseBasicInfoList")
    @ApiOperation(value = "企业信息查询")
    public AjaxResult getEEnterpriseBasicInfoList(String enterpriseName,String unifiedSocialCreditCode,String isAboveDesignatedSize,String isHighTech){
        return AjaxResult.success(service.getEEnterpriseBasicInfoList(enterpriseName, unifiedSocialCreditCode, isAboveDesignatedSize, isHighTech));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询企业信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "企业信息保存")
    public AjaxResult save(@RequestBody EEnterpriseBasicInfo entity) {
        return service.save(entity) ? AjaxResult.success(entity): AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "企业信息修改")
    public AjaxResult update(@RequestBody EEnterpriseBasicInfo entity) {
        entity.setUpdateTime(LocalDateTime.now());
        return service.updateById(entity) ? AjaxResult.success(entity): AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "企业信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EEnterpriseBasicInfo.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String enterpriseName,String unifiedSocialCreditCode,String isAboveDesignatedSize,String isHighTech) {
        ExcelExportUtil.exportExcel(response,service.getEEnterpriseBasicInfoList(enterpriseName, unifiedSocialCreditCode, isAboveDesignatedSize, isHighTech), EEnterpriseBasicInfo.class, "企业信息","企业信息");
    }

}
